#include "define.h"
#include "mode15k.h"


/* Text */

static CRTCPARAM mode640x200_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      896, 640, 640, 704, 784, 800,   263, 200, 200, 221, 223, 240,

// width height HPlr VPlr DblScn Intrlc Iratio
     640,   200,   1,   1,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   14138880,  15780,   6000
};


/* VGA */


static CRTCPARAM mode640x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      848, 640, 640, 696, 776, 840,   262, 240, 240, 241, 249, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
     640,   240,   1,   1,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   13330560,  15720,   6000
};


static CRTCPARAM mode640x476_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      848, 640, 640, 688, 776, 840,   262, 238, 240, 241, 248, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
     640,   476,   1,   1,     0,     1,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   13356000,  15750,   6000
};



/* VESA */


static CRTCPARAM mode640x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      848, 640, 640, 688, 776, 840,   262, 240, 240, 241, 248, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
     640,   480,   1,   1,     0,     1,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   13356000,  15750,   6000
};


static CRTCPARAM mode640x400_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      848, 640, 640, 688, 776, 840,   262, 200, 200, 221, 229, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
     640,   400,   1,   1,     0,     1,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   13356000,  15750,   6000
};


static CRTCPARAM mode512x384_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      672, 512, 512, 552, 608, 664,   262, 192, 192, 218, 226, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
     512,   384,   1,   1,     0,     1,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   10584000,  15750,   6000
};

static CRTCPARAM mode400x300_50 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      528, 400, 400, 424, 480, 520,   329, 300, 300, 304, 312, 328,

// width height HPlr VPlr DblScn Intrlc Iratio
     400,   300,   1,   1,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
    8685600,  16450,   5000
};

static CRTCPARAM mode320x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      424, 320, 320, 352, 392, 416,   262, 240, 240, 242, 250, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
     320,   480,   1,   1,     0,     1,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
    6678000,  15750,   6000
};

static CRTCPARAM mode320x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      424, 320, 320, 352, 392, 416,   263, 240, 240, 242, 250, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
     320,   240,   1,   1,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
    6690720,  15780,   6000
};


static CRTCPARAM mode320x200_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      424, 320, 320, 352, 392, 416,   263, 200, 200, 222, 230, 262,

// width height HPlr VPlr DblScn Intrlc Iratio
     320,   200,   1,   1,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
    6690720,  15780,   6000
};



/* Add Custom Modes here */

static CRTCPARAM mode384x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      512, 384, 384, 424, 472, 504,   262, 224, 224, 234, 242, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
     384,   224,   1,   1,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
    8048640,  15720,   6000
};


static CRTCPARAM mode256x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      344, 256, 256, 288, 320, 336,   261, 240, 240, 242, 250, 260,

// width height HPlr VPlr DblScn Intrlc Iratio
     256,   240,   1,   1,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
    5387040,  15660,   6000
};

static CRTCPARAM mode864x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
     1160, 864, 864, 936,1048,1152,   262, 240, 240, 241, 249, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
     864,   240,   1,   1,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   18235200,  15720,   6000
};

static CRTCPARAM mode864x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
     1160, 864, 864, 936,1048,1152,   262, 240, 240, 241, 249, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
     864,   480,   1,   1,     0,     1,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   18270000,  15750,   6000
};

static CRTCPARAM mode1024x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
     1376,1024,1024,1112,1240,1368,   262, 240, 240, 241, 249, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
    1024,   240,   1,   1,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   21630720,  15720,   6000
};

static CRTCPARAM mode1024x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
     1376,1024,1024,1112,1240,1368,   262, 240, 240, 241, 249, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
    1024,   480,   1,   1,     0,     1,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   21672000,  15750,   6000
};

static CRTCPARAM mode368x224_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      496, 368, 368, 408, 456, 488,   262, 224, 224, 234, 241, 261,

// width height HPlr VPlr DblScn Intrlc Iratio
     368,   224,   1,   1,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
    7797120,  15720,   6000
};




SCRLIST ScrModeList[] = {
/* Text, VGA */
        { 640, 200, &mode640x200_60},

/* VESA, VGA */
        { 320, 200, &mode320x200_60},
        { 640, 240, &mode640x240_60},
        { 640, 476, &mode640x476_60},
        { 640, 480, &mode640x480_60},

/* Generic VESA modes */
        { 320, 240, &mode320x240_60},
        { 320, 480, &mode320x480_60},
        { 400, 300, &mode400x300_50},
        { 512, 384, &mode512x384_60},
        { 640, 400, &mode640x400_60},

/* Custom VESA modes */
        { 384, 224, &mode384x224_60},
        { 368, 224, &mode368x224_60},
        { 256, 240, &mode256x240_60},
        { 864, 240, &mode864x240_60},
        { 864, 480, &mode864x480_60},
        {1024, 240, &mode1024x240_60},
        {1024, 480, &mode1024x480_60},
        {   0,   0, &mode640x480_60},
};
