#include "define.h"

typedef struct {
	int HTotal;
	int HDisp;
	int HBStart;
	int HSStart;
	int HSEnd;
	int HBEnd;
	int VTotal;
	int VDisp;
	int VBStart;
	int VSStart;
	int VSEnd;
	int VBEnd;

	int width;
	int height;
	int hpolarity;
	int vpolarity;
	int doublescan;
	int interlace;
	int interlaceratio;

	long dotclockHz;
	long horzHz;
	long vert001Hz;
} CRTCPARAM;

typedef struct {
	int forx;
	int fory;
	CRTCPARAM *cp;
} SCRLIST;

int GetMode15KHz(CRTCPARAM *cp, int xres, int yres);
int GetVGAMode15KHz(CRTCPARAM *cp, int xres, int yres);
void SetGenericVGARegister(CRTCPARAM *cp, int h_sync_delay, int h_disp_delay);

long CalcDotclock(long Vert001Hz, int HTotal, int VTotal, int interlace);
long CalcHorizontalHz(long dotclockHz, int HTotal);
long CalcVert001Hz(long dotclockHz, int HTotal, int VTotal, int interlace);
void DispCrtcParam(CRTCPARAM *cp);
void SetHVPolarity(int HPolar, int VPolar);
DWORD BitMov(DWORD dstdata, int dstbitpos, DWORD srcdata, int srcbitpos);
void SetSeqReg(BYTE __idx, BYTE data);
BYTE GetSeqReg(BYTE __idx);
BYTE GetAtrbData(BYTE __idx);
void SetAtrbData(BYTE __idx, BYTE data);
void SetCrtcReg(BYTE __idx, BYTE data);
BYTE GetCrtcReg(BYTE __idx);
int GetSeqDivider(void);

void _outb(unsigned int edx, BYTE al);
BYTE _inb(unsigned int edx);
void _outw(unsigned int edx, WORD ax);
WORD _inw(unsigned int edx);
void _outl(unsigned int edx, DWORD eax);
DWORD _inl(unsigned int edx);

void DisableGenerateSignal(void);
void EnableGenerateSignal(void);

void SetSeqDiv(int div);
void Set25MHz(void);
void Set28MHz(void);
void Set12MHz(void);
void Set14MHz(void);
void SetTextHeight(int height);
void SetTextWidth(int width);
BYTE GetVGABytesPerLine(void);
void SetVGABytesPerLine(BYTE d0);

void AdjustCenter(CRTCPARAM *cp, int center_x, int center_y);
void SetText80x25(int center_x, int center_y, int h_sync_delay, int h_disp_delay);
